---
title: "Set Filter - Data Updates"
enterprise: true
framework: javascript
version: "36.1.0"
---

# Set Filter - Data Updates

This section describes how changing data through [Cell Editing](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/cell-editing/) and the application [Updating Data](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/data-update/) impacts the Set Filter's values. This is only applicable when the Set Filter is taking its values from the grid's data.

## Row / Cell Updates

Row / Cell updates refers to any of the following:

- All edits via the grid's UI such as [Cell Editing](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/cell-editing/) and [Clipboard Operations](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/clipboard/).
- Using the grid's [Single Row / Cell Update API](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/data-update-single-row-cell/) i.e. `rowNode.setData(data)` and `rowNode.setDataValue(col,value)` API methods.

Filter Values will be refreshed when data is updated through any of these methods.

Here are the rules that determine how Filter Values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Cell editing does not re-execute filtering by default, so the row will not be filtered out even though the value in the cell is not selected in the filter. This default behaviour mimics how Excel works.

To execute filtering on cell edits, listen to `CellValueChanged` events and trigger filtering as shown below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. |

```js
const gridOptions = {
    onCellValueChanged: params => {
        // trigger filtering on cell edits
        params.api.onFilterChanged();
    },

    // other grid options ...
}
```

The following example demonstrates Cell Editing with the Set Filter. Try the following:

**Without selecting any Filter Values:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and note it gets added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and notice it gets added to the Filter List but it is **not selected**.
- Note that although `'X'` is not selected in the filter the row still appears in the grid. This is because grid filtering is not triggered for cell edits.

#### Cell Editing Updates

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  rowData: getRowData(),
  columnDefs: [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ],
  sideBar: "filters",
  onFirstDataRendered: onFirstDataRendered,
};

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

function reset() {
  gridApi!.setFilterModel(null);
  gridApi!.setGridOption("rowData", getRowData());
}

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.getToolPanelInstance("filters")!.expandFilters();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).reset = reset;
}
```

[Live example: Cell Editing Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/cell-editing-updates/typescript)

## Transaction Updates

Transaction Updates refers to any of the following:

- Updating data via [Transactions](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/data-update-transactions/) API.
- Updating data via [Async Transactions](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/data-update-high-frequency/) API.
- Changes to Row Data and providing [Row ID](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/row-ids/) (as this uses Transactions underneath the hood).

Filter values are refreshed when data is updated using any of these methods.

Here are the rules that determine how filter values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive.
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Unlike [Cell Editing](#row--cell-updates), transaction updates will execute filtering in the grid.

The following example demonstrates these rules. Try the following:

**Without selecting any filter values:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **selected**.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **not selected**.
- Note that as `'AX'` is unselected in the filter list it has also been filtered out of the grid. This is because transaction updates also triggers grid filtering.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **not selected**.

#### Transaction Updates

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  rowData: getRowData(),
  columnDefs: [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ],
  sideBar: "filters",
  onFirstDataRendered: onFirstDataRendered,
};

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

function updateFirstRow() {
  const firstRow = gridApi!.getDisplayedRowAtIndex(0);
  if (firstRow) {
    const firstRowData = firstRow.data;
    firstRowData["col1"] += "X";
    gridApi!.applyTransaction({ update: [firstRowData] });
  }
}

function addDRow() {
  gridApi!.applyTransaction({ add: [{ col1: "D" }] });
}

function reset() {
  gridApi!.setFilterModel(null);
  gridApi!.setGridOption("rowData", getRowData());
}

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.getToolPanelInstance("filters")!.expandFilters();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).updateFirstRow = updateFirstRow;
  (<any>window).addDRow = addDRow;
  (<any>window).reset = reset;
}
```

[Live example: Transaction Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/transaction-updates/typescript)

## Setting New Data

When `api.setGridOption('rowData', data)` is called existing filter selections are kept when new rows are added. However it is possible to clear filter selections using: `api.setFilterModel(null)`.

The following example demonstrates how `api.setGridOption('rowData', data)` affects filter selections. Try the following:

- Deselect value 'A' from the set filter list and click the **Apply Data Update 1** button which calls `api.setGridOption('rowData', newData)` to add new data with extra rows to the grid.
- Notice 'A' remains deselected after new data is supplied to the grid.
- Clicking **Reset** invokes `api.setGridOption('rowData', origData)` to restore the original data but also clears any selections using `api.setFilterModel(null)`.
- Apply the filters so only 'B' is selected and click **Apply Data Update 1**. Notice how 'B' is no longer a filter value and therefore no longer in the filter list. Click **Apply Data Update 2** and notice how 'B' returns to the filter list but remains unselected.

#### Setting New Data

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  TextEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ],
  sideBar: "filters",
  rowData: getRowData(),
  onFirstDataRendered: onFirstDataRendered,
};

function getRowData() {
  return [{ col1: "A" }, { col1: "A" }, { col1: "B" }, { col1: "C" }];
}

function updateOne() {
  const newData = [
    { col1: "A" },
    { col1: "A" },
    { col1: "C" },
    { col1: "D" },
    { col1: "E" },
  ];
  gridApi!.setGridOption("rowData", newData);
}

function updateTwo() {
  const newData = [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "C" },
    { col1: "D" },
    { col1: "E" },
    { col1: "B" },
    { col1: "B" },
  ];
  gridApi!.setGridOption("rowData", newData);
}

function reset() {
  gridApi!.setFilterModel(null);
  gridApi!.setGridOption("rowData", getRowData());
}

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.getToolPanelInstance("filters")!.expandFilters();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).updateOne = updateOne;
  (<any>window).updateTwo = updateTwo;
  (<any>window).reset = reset;
}
```

[Live example: Setting New Data](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/setting-new-data/typescript)


---
title: "Set Filter - Data Updates"
enterprise: true
framework: angular
version: "36.1.0"
---

# Set Filter - Data Updates

This section describes how changing data through [Cell Editing](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/cell-editing/) and the application [Updating Data](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/data-update/) impacts the Set Filter's values. This is only applicable when the Set Filter is taking its values from the grid's data.

## Row / Cell Updates

Row / Cell updates refers to any of the following:

- All edits via the grid's UI such as [Cell Editing](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/cell-editing/) and [Clipboard Operations](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/clipboard/).
- Using the grid's [Single Row / Cell Update API](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/data-update-single-row-cell/) i.e. `rowNode.setData(data)` and `rowNode.setDataValue(col,value)` API methods.

Filter Values will be refreshed when data is updated through any of these methods.

Here are the rules that determine how Filter Values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Cell editing does not re-execute filtering by default, so the row will not be filtered out even though the value in the cell is not selected in the filter. This default behaviour mimics how Excel works.

To execute filtering on cell edits, listen to `CellValueChanged` events and trigger filtering as shown below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. |

```ts
<ag-grid-angular
    [onCellValueChanged]="onCellValueChanged"
    /* other grid options ... */ />

this.onCellValueChanged = params => {
    // trigger filtering on cell edits
    params.api.onFilterChanged();
};
```

The following example demonstrates Cell Editing with the Set Filter. Try the following:

**Without selecting any Filter Values:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and note it gets added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and notice it gets added to the Filter List but it is **not selected**.
- Note that although `'X'` is not selected in the filter the row still appears in the grid. This is because grid filtering is not triggered for cell edits.

#### Cell Editing Updates

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button (click)="reset()">Reset</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [rowData]="rowData"
      [columnDefs]="columnDefs"
      [sideBar]="sideBar"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  rowData: any[] | null = getRowData();
  columnDefs: ColDef[] = [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ];
  sideBar: SideBarDef | string | string[] | boolean | null = "filters";

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }

  reset() {
    this.gridApi.setFilterModel(null);
    this.gridApi.setGridOption("rowData", getRowData());
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}
```

[Live example: Cell Editing Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/cell-editing-updates/angular)

## Transaction Updates

Transaction Updates refers to any of the following:

- Updating data via [Transactions](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/data-update-transactions/) API.
- Updating data via [Async Transactions](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/data-update-high-frequency/) API.
- Changes to Row Data and providing [Row ID](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/row-ids/) (as this uses Transactions underneath the hood).

Filter values are refreshed when data is updated using any of these methods.

Here are the rules that determine how filter values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive.
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Unlike [Cell Editing](#row--cell-updates), transaction updates will execute filtering in the grid.

The following example demonstrates these rules. Try the following:

**Without selecting any filter values:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **selected**.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **not selected**.
- Note that as `'AX'` is unselected in the filter list it has also been filtered out of the grid. This is because transaction updates also triggers grid filtering.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **not selected**.

#### Transaction Updates

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <label>Transaction Updates: </label>
      <button (click)="updateFirstRow()">Update First Displayed Row</button>
      <button (click)="addDRow()">Add New 'D' Row</button>
      <button (click)="reset()" style="margin-left: 20px">Reset</button>
    </div>

    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [rowData]="rowData"
      [columnDefs]="columnDefs"
      [sideBar]="sideBar"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  rowData: any[] | null = getRowData();
  columnDefs: ColDef[] = [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ];
  sideBar: SideBarDef | string | string[] | boolean | null = "filters";

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }

  updateFirstRow() {
    const firstRow = this.gridApi.getDisplayedRowAtIndex(0);
    if (firstRow) {
      const firstRowData = firstRow.data;
      firstRowData["col1"] += "X";
      this.gridApi.applyTransaction({ update: [firstRowData] });
    }
  }

  addDRow() {
    this.gridApi.applyTransaction({ add: [{ col1: "D" }] });
  }

  reset() {
    this.gridApi.setFilterModel(null);
    this.gridApi.setGridOption("rowData", getRowData());
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}
```

[Live example: Transaction Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/transaction-updates/angular)

## Setting New Data

When `api.setGridOption('rowData', data)` is called existing filter selections are kept when new rows are added. However it is possible to clear filter selections using: `api.setFilterModel(null)`.

The following example demonstrates how `api.setGridOption('rowData', data)` affects filter selections. Try the following:

- Deselect value 'A' from the set filter list and click the **Apply Data Update 1** button which calls `api.setGridOption('rowData', newData)` to add new data with extra rows to the grid.
- Notice 'A' remains deselected after new data is supplied to the grid.
- Clicking **Reset** invokes `api.setGridOption('rowData', origData)` to restore the original data but also clears any selections using `api.setFilterModel(null)`.
- Apply the filters so only 'B' is selected and click **Apply Data Update 1**. Notice how 'B' is no longer a filter value and therefore no longer in the filter list. Click **Apply Data Update 2** and notice how 'B' returns to the filter list but remains unselected.

#### Setting New Data

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button (click)="updateOne()">Apply Data Update 1</button>
      <button (click)="updateTwo()">Apply Data Update 2</button>
      <button (click)="reset()" style="margin-left: 5px">Reset</button>
    </div>

    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [sideBar]="sideBar"
      [rowData]="rowData"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ];
  sideBar: SideBarDef | string | string[] | boolean | null = "filters";
  rowData: any[] | null = getRowData();

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }

  updateOne() {
    const newData = [
      { col1: "A" },
      { col1: "A" },
      { col1: "C" },
      { col1: "D" },
      { col1: "E" },
    ];
    this.gridApi.setGridOption("rowData", newData);
  }

  updateTwo() {
    const newData = [
      { col1: "A" },
      { col1: "A" },
      { col1: "B" },
      { col1: "C" },
      { col1: "D" },
      { col1: "E" },
      { col1: "B" },
      { col1: "B" },
    ];
    this.gridApi.setGridOption("rowData", newData);
  }

  reset() {
    this.gridApi.setFilterModel(null);
    this.gridApi.setGridOption("rowData", getRowData());
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function getRowData() {
  return [{ col1: "A" }, { col1: "A" }, { col1: "B" }, { col1: "C" }];
}
```

[Live example: Setting New Data](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/setting-new-data/angular)


---
title: "Set Filter - Data Updates"
enterprise: true
framework: react
version: "36.1.0"
---

# Set Filter - Data Updates

This section describes how changing data through [Cell Editing](https://www.ag-grid.com/archive/36.1.0/react-data-grid/cell-editing/) and the application [Updating Data](https://www.ag-grid.com/archive/36.1.0/react-data-grid/data-update/) impacts the Set Filter's values. This is only applicable when the Set Filter is taking its values from the grid's data.

## Row / Cell Updates

Row / Cell updates refers to any of the following:

- All edits via the grid's UI such as [Cell Editing](https://www.ag-grid.com/archive/36.1.0/react-data-grid/cell-editing/) and [Clipboard Operations](https://www.ag-grid.com/archive/36.1.0/react-data-grid/clipboard/).
- Using the grid's [Single Row / Cell Update API](https://www.ag-grid.com/archive/36.1.0/react-data-grid/data-update-single-row-cell/) i.e. `rowNode.setData(data)` and `rowNode.setDataValue(col,value)` API methods.

Filter Values will be refreshed when data is updated through any of these methods.

Here are the rules that determine how Filter Values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Cell editing does not re-execute filtering by default, so the row will not be filtered out even though the value in the cell is not selected in the filter. This default behaviour mimics how Excel works.

To execute filtering on cell edits, listen to `CellValueChanged` events and trigger filtering as shown below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. |

```jsx
const onCellValueChanged = params => {
    // trigger filtering on cell edits
    params.api.onFilterChanged();
};

<AgGridReact onCellValueChanged={onCellValueChanged} />
```

The following example demonstrates Cell Editing with the Set Filter. Try the following:

**Without selecting any Filter Values:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and note it gets added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and notice it gets added to the Filter List but it is **not selected**.
- Note that although `'X'` is not selected in the filter the row still appears in the grid. This is because grid filtering is not triggered for cell edits.

#### Cell Editing Updates

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
];

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ]);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }, []);

  const reset = useCallback(() => {
    gridRef.current!.api.setFilterModel(null);
    setRowData(getRowData());
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button onClick={reset}>Reset</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              sideBar={"filters"}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Editing Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/cell-editing-updates/reactFunctionalTs)

## Transaction Updates

Transaction Updates refers to any of the following:

- Updating data via [Transactions](https://www.ag-grid.com/archive/36.1.0/react-data-grid/data-update-transactions/) API.
- Updating data via [Async Transactions](https://www.ag-grid.com/archive/36.1.0/react-data-grid/data-update-high-frequency/) API.
- Changes to Row Data and providing [Row ID](https://www.ag-grid.com/archive/36.1.0/react-data-grid/row-ids/) (as this uses Transactions underneath the hood).

Filter values are refreshed when data is updated using any of these methods.

Here are the rules that determine how filter values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive.
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Unlike [Cell Editing](#row--cell-updates), transaction updates will execute filtering in the grid.

The following example demonstrates these rules. Try the following:

**Without selecting any filter values:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **selected**.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **not selected**.
- Note that as `'AX'` is unselected in the filter list it has also been filtered out of the grid. This is because transaction updates also triggers grid filtering.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **not selected**.

#### Transaction Updates

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  RowApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
];

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ]);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }, []);

  const updateFirstRow = useCallback(() => {
    const firstRow = gridRef.current!.api.getDisplayedRowAtIndex(0);
    if (firstRow) {
      const firstRowData = firstRow.data;
      firstRowData["col1"] += "X";
      gridRef.current!.api.applyTransaction({ update: [firstRowData] });
    }
  }, []);

  const addDRow = useCallback(() => {
    gridRef.current!.api.applyTransaction({ add: [{ col1: "D" }] });
  }, []);

  const reset = useCallback(() => {
    gridRef.current!.api.setFilterModel(null);
    setRowData(getRowData());
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <label>Transaction Updates: </label>
            <button onClick={updateFirstRow}>Update First Displayed Row</button>
            <button onClick={addDRow}>Add New 'D' Row</button>
            <button onClick={reset} style={{ marginLeft: "20px" }}>
              Reset
            </button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              sideBar={"filters"}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Transaction Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/transaction-updates/reactFunctionalTs)

## Setting New Data

When `api.setGridOption('rowData', data)` is called existing filter selections are kept when new rows are added. However it is possible to clear filter selections using: `api.setFilterModel(null)`.

The following example demonstrates how `api.setGridOption('rowData', data)` affects filter selections. Try the following:

- Deselect value 'A' from the set filter list and click the **Apply Data Update 1** button which calls `api.setGridOption('rowData', newData)` to add new data with extra rows to the grid.
- Notice 'A' remains deselected after new data is supplied to the grid.
- Clicking **Reset** invokes `api.setGridOption('rowData', origData)` to restore the original data but also clears any selections using `api.setFilterModel(null)`.
- Apply the filters so only 'B' is selected and click **Apply Data Update 1**. Notice how 'B' is no longer a filter value and therefore no longer in the filter list. Click **Apply Data Update 2** and notice how 'B' returns to the filter list but remains unselected.

#### Setting New Data

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  TextEditorModule,
];

function getRowData() {
  return [{ col1: "A" }, { col1: "A" }, { col1: "B" }, { col1: "C" }];
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Set Filter Column",
      field: "col1",
      filter: "agSetColumnFilter",
      editable: true,
      minWidth: 250,
    },
  ]);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }, []);

  const updateOne = useCallback(() => {
    const newData = [
      { col1: "A" },
      { col1: "A" },
      { col1: "C" },
      { col1: "D" },
      { col1: "E" },
    ];
    setRowData(newData);
  }, []);

  const updateTwo = useCallback(() => {
    const newData = [
      { col1: "A" },
      { col1: "A" },
      { col1: "B" },
      { col1: "C" },
      { col1: "D" },
      { col1: "E" },
      { col1: "B" },
      { col1: "B" },
    ];
    setRowData(newData);
  }, []);

  const reset = useCallback(() => {
    gridRef.current!.api.setFilterModel(null);
    setRowData(getRowData());
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button onClick={updateOne}>Apply Data Update 1</button>
            <button onClick={updateTwo}>Apply Data Update 2</button>
            <button onClick={reset} style={{ marginLeft: "5px" }}>
              Reset
            </button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              sideBar={"filters"}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Setting New Data](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/setting-new-data/reactFunctionalTs)


---
title: "Set Filter - Data Updates"
enterprise: true
framework: vue
version: "36.1.0"
---

# Set Filter - Data Updates

This section describes how changing data through [Cell Editing](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/cell-editing/) and the application [Updating Data](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/data-update/) impacts the Set Filter's values. This is only applicable when the Set Filter is taking its values from the grid's data.

## Row / Cell Updates

Row / Cell updates refers to any of the following:

- All edits via the grid's UI such as [Cell Editing](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/cell-editing/) and [Clipboard Operations](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/clipboard/).
- Using the grid's [Single Row / Cell Update API](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/data-update-single-row-cell/) i.e. `rowNode.setData(data)` and `rowNode.setDataValue(col,value)` API methods.

Filter Values will be refreshed when data is updated through any of these methods.

Here are the rules that determine how Filter Values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Cell editing does not re-execute filtering by default, so the row will not be filtered out even though the value in the cell is not selected in the filter. This default behaviour mimics how Excel works.

To execute filtering on cell edits, listen to `CellValueChanged` events and trigger filtering as shown below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. |

```ts
<ag-grid-vue
    :onCellValueChanged="onCellValueChanged"
    /* other grid options ... */>
</ag-grid-vue>

this.onCellValueChanged = params => {
    // trigger filtering on cell edits
    params.api.onFilterChanged();
};
```

The following example demonstrates Cell Editing with the Set Filter. Try the following:

**Without selecting any Filter Values:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and note it gets added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Change (Cell Edit) a `'B'` cell value to `'X'` and notice it gets added to the Filter List but it is **not selected**.
- Note that although `'X'` is not selected in the filter the row still appears in the grid. This is because grid filtering is not triggered for cell edits.

#### Cell Editing Updates

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button v-on:click="reset()">Reset</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :rowData="rowData"
        :columnDefs="columnDefs"
        :sideBar="sideBar"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowData = ref<any[] | null>(getRowData());
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Set Filter Column",
        field: "col1",
        filter: "agSetColumnFilter",
        editable: true,
        minWidth: 250,
      },
    ]);
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters",
    );

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.getToolPanelInstance("filters")!.expandFilters();
    }
    function reset() {
      gridApi.value!.setFilterModel(null);
      gridApi.value!.setGridOption("rowData", getRowData());
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowData,
      columnDefs,
      sideBar,
      onGridReady,
      onFirstDataRendered,
      reset,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Editing Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/cell-editing-updates/vue3)

## Transaction Updates

Transaction Updates refers to any of the following:

- Updating data via [Transactions](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/data-update-transactions/) API.
- Updating data via [Async Transactions](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/data-update-high-frequency/) API.
- Changes to Row Data and providing [Row ID](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/row-ids/) (as this uses Transactions underneath the hood).

Filter values are refreshed when data is updated using any of these methods.

Here are the rules that determine how filter values are selected:

- **Filter Inactive**: Before the update 'all' values in the filter were selected (as the filter was inactive). The filter list will be updated reflecting the data change and all values will remain selected leaving the filter inactive.
- **Filter Active**: Before the update 'some' values in the filter were selected (as the filter was active). The filter list will be updated reflecting the data change, however previous selections will remain intact as long as the filter value still exists after any transaction(s). If the update resulted in a new filter value, the new filter value will not be selected.

Unlike [Cell Editing](#row--cell-updates), transaction updates will execute filtering in the grid.

The following example demonstrates these rules. Try the following:

**Without selecting any filter values:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **selected**.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **selected**.

**Click 'Reset' and deselect 'C' in the Filter List:**

- Click **Update First Displayed Row**: this calls `api.applyTransaction()` and updates the value in the first row. Note `'AX'` now appears in the filter list and is **not selected**.
- Note that as `'AX'` is unselected in the filter list it has also been filtered out of the grid. This is because transaction updates also triggers grid filtering.
- Click **Add New 'D' Row**: this calls `api.applyTransaction()` and adds a new row to the grid. Note `'D'` has been added to the filter list and is **not selected**.

#### Transaction Updates

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  SideBarDef,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextEditorModule,
]);

function getRowData() {
  return [
    { col1: "A" },
    { col1: "A" },
    { col1: "B" },
    { col1: "B" },
    { col1: "C" },
    { col1: "C" },
  ];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <label>Transaction Updates: </label>
        <button v-on:click="updateFirstRow()">Update First Displayed Row</button>
        <button v-on:click="addDRow()">Add New 'D' Row</button>
        <button v-on:click="reset()" style="margin-left: 20px">Reset</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :rowData="rowData"
        :columnDefs="columnDefs"
        :sideBar="sideBar"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowData = ref<any[] | null>(getRowData());
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Set Filter Column",
        field: "col1",
        filter: "agSetColumnFilter",
        editable: true,
        minWidth: 250,
      },
    ]);
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters",
    );

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.getToolPanelInstance("filters")!.expandFilters();
    }
    function updateFirstRow() {
      const firstRow = gridApi.value!.getDisplayedRowAtIndex(0);
      if (firstRow) {
        const firstRowData = firstRow.data;
        firstRowData["col1"] += "X";
        gridApi.value!.applyTransaction({ update: [firstRowData] });
      }
    }
    function addDRow() {
      gridApi.value!.applyTransaction({ add: [{ col1: "D" }] });
    }
    function reset() {
      gridApi.value!.setFilterModel(null);
      gridApi.value!.setGridOption("rowData", getRowData());
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowData,
      columnDefs,
      sideBar,
      onGridReady,
      onFirstDataRendered,
      updateFirstRow,
      addDRow,
      reset,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Transaction Updates](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/transaction-updates/vue3)

## Setting New Data

When `api.setGridOption('rowData', data)` is called existing filter selections are kept when new rows are added. However it is possible to clear filter selections using: `api.setFilterModel(null)`.

The following example demonstrates how `api.setGridOption('rowData', data)` affects filter selections. Try the following:

- Deselect value 'A' from the set filter list and click the **Apply Data Update 1** button which calls `api.setGridOption('rowData', newData)` to add new data with extra rows to the grid.
- Notice 'A' remains deselected after new data is supplied to the grid.
- Clicking **Reset** invokes `api.setGridOption('rowData', origData)` to restore the original data but also clears any selections using `api.setFilterModel(null)`.
- Apply the filters so only 'B' is selected and click **Apply Data Update 1**. Notice how 'B' is no longer a filter value and therefore no longer in the filter list. Click **Apply Data Update 2** and notice how 'B' returns to the filter list but remains unselected.

#### Setting New Data

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  TextEditorModule,
]);

function getRowData() {
  return [{ col1: "A" }, { col1: "A" }, { col1: "B" }, { col1: "C" }];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button v-on:click="updateOne()">Apply Data Update 1</button>
        <button v-on:click="updateTwo()">Apply Data Update 2</button>
        <button v-on:click="reset()" style="margin-left: 5px">Reset</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :sideBar="sideBar"
        :rowData="rowData"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Set Filter Column",
        field: "col1",
        filter: "agSetColumnFilter",
        editable: true,
        minWidth: 250,
      },
    ]);
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters",
    );
    const rowData = ref<any[] | null>(getRowData());

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.getToolPanelInstance("filters")!.expandFilters();
    }
    function updateOne() {
      const newData = [
        { col1: "A" },
        { col1: "A" },
        { col1: "C" },
        { col1: "D" },
        { col1: "E" },
      ];
      gridApi.value!.setGridOption("rowData", newData);
    }
    function updateTwo() {
      const newData = [
        { col1: "A" },
        { col1: "A" },
        { col1: "B" },
        { col1: "C" },
        { col1: "D" },
        { col1: "E" },
        { col1: "B" },
        { col1: "B" },
      ];
      gridApi.value!.setGridOption("rowData", newData);
    }
    function reset() {
      gridApi.value!.setFilterModel(null);
      gridApi.value!.setGridOption("rowData", getRowData());
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      sideBar,
      rowData,
      onGridReady,
      onFirstDataRendered,
      updateOne,
      updateTwo,
      reset,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Setting New Data](https://www.ag-grid.com/archive/36.1.0/examples/filter-set-data-updates/setting-new-data/vue3)
